/*
 * $Id: hdn_common.h,v 1.6 2003/02/04 06:54:13 xvr Exp $
 * Created: 08/21/2002
 *
 * xvr (c) 2002
 * xvr@crazyboy.com
 */

#ifndef _HDN_COMMON_H_
#define _HDN_COMMON_H_

#include "hydan.h"

/*
 * xors b onto a
 */
void hdn_xor (void *a, void *b, int len);

/*
 * returns the number of bits needed to encode n
 */
int hdn_log2 (long long n);

/*
 * takes in the password and uses it to seed the random number
 * generator
 */
void hdn_srandom (char *pass);

/*
 * returns the next address to embed/decode from in the code sections.
 * NULL if none left.
 */
char *hdn_get_next_address (struct hdn_host_section *host_sections);

/*
 * returns 1 if the file pointed to is an exe file we can process 
 * returns 0 otherwise
 */
int hdn_is_valid_exe (unsigned char *bin);

/*
 * returns a null-terminated array of the data we can use to
 * embed/decode info, along with their respective starting offsets in
 * the file stored at code_offsets[]
 */
struct hdn_host_section *hdn_get_code_locs (unsigned char *file_start);

/*
 * dumps the content of a file into a hdn_data structure
 */
struct hdn_data *hdn_fileread (char *filename);

/*
 * dumps the content of a fd to a hdn_data structure
 */
struct hdn_data *hdn_fdread (int fd);

/*
 * saves the content of a hdn_data structure into a file
 */
void hdn_filewrite (char *filename, struct hdn_data *data);

/*
 * same as above, but to into an fd
 */
void hdn_fdwrite (int fd, struct hdn_data *data);

#endif
