/*
 * $Id: hdn_insns.h,v 1.6 2003/01/19 02:02:21 xvr Exp $
 * Created: 08/23/2002
 *
 * xvr (c) 2002-2003
 * xvr@crazyboy.com
 */


#ifndef _HDN_INSNS_H_
#define _HSN_INSNS_H_

#include "hydan.h"

/*
 * tells us if the current instruction is valid for use in our stego
 * or not.  Returns the number of bits that can be encoded into that
 * particular instruction.
 */
int  hdn_is_valid_insn (struct instr *insn, unsigned char *host_loc);

/*
 * returns the value encoded in the current instruction, and stores
 * its number of bits into numbits (numbits can be null if that info
 * is not needed)
 */
int  hdn_insn_val (struct instr *insn, unsigned char *host, int *numbits);

/*
 * same as above, except it returns the description of the instruction
 * set, NULL if not found.
 */
char *hdn_insn_desc (struct instr *insn, unsigned char *host, char **insn_dsc);


/*
 * encodes the instruction
 * returns the number of bits encoded
 */
int hdn_flip_insn (struct instr *insn, unsigned char *host_loc,
		   unsigned char *source_loc, int bit_offset);

/*
 * returns 1 if the instruction flips imm to its negative value (like
 * add/sub) and the imm is negative.
 */
int hdn_is_neg_insn (struct instr *insn, unsigned char *host);

#endif 
