/*
 * $Id: hydan.h,v 1.8 2003/02/04 06:54:13 xvr Exp $
 * Created: 08/21/2002
 *
 * xvr (c) 2002
 * xvr@crazyboy.com
 */

#ifndef _HYDAN_H_
#define _HYDAN_H_

#if (defined(__CYGWIN32__) || defined(_Windows) || defined(_WIN32))
#include <windows.h>
#else
#include <elf.h>
#endif

#include <fcntl.h>
#include <limits.h>
#include <math.h>
#include <openssl/evp.h>
#include <pwd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>

#include "libdis.h"

/*
 * number of instructions to skip max in random walk.  The more, the
 * slower..
 */
#define HDN_MAX_SKIP_INSNS 100

/*
 * _PASSWORD_LEN is not always defined
 */
#ifndef _PASSWORD_LEN
#ifdef PASS_MAX
#define _PASSWORD_LEN PASS_MAX
#else
#define _PASSWORD_LEN 8
#endif
#endif

/*
 * holds arbitrarily sized data
 */
struct hdn_data
{
    long long int sz;
    
    char content[1]; //placeholder for more data
};

/*
 * a linked list of data, specially geared to hold the multiple code
 * sections we can use to embed data into.
 */
struct hdn_host_section
{
    struct hdn_host_section *next;

    long long int   offset; //data offset in original file
    struct hdn_data data;   //data itself
};    

#include "hdn_common.h"
#include "hdn_crypto.h"
#include "hdn_decode.h"
#include "hdn_embed.h"
#include "hdn_insns.h"
#include "hdn_stats.h"

#endif
